(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("moment"), require("angular"));
	else if(typeof define === 'function' && define.amd)
		define(["moment", "angular"], factory);
	else {
		var a = typeof exports === 'object' ? factory(require("moment"), require("angular")) : factory(root["moment"], root["angular"]);
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, function(__WEBPACK_EXTERNAL_MODULE_3__, __WEBPACK_EXTERNAL_MODULE_4__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__datepicker_less__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__datepicker_less___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__datepicker_less__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__datepicker_html__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__datepicker_html___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1__datepicker_html__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_moment__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_moment__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_angular__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_angular___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_angular__);





var DAYS_IN_MONTH = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
var DAYS = ['日', '一', '二', '三', '四', '五', '六'];
var VIEWS = {
  year: 0,
  month: 1,
  day: 2,
  hour: 3
};

function viewAfter(a, b) {
  return VIEWS[a] - VIEWS[b] > 0;
}

function isChildrenOf(source, target) {
  if (target.parentNode) {
    var parent = target.parentNode;
    if (parent === source) {
      return true;
    } else {
      return isChildrenOf(source, parent);
    }
  } else {
    return false;
  }
}

function getDays(year, month) {
  if (month === 1) {
    if (year % 4 === 0 && (year % 100 !== 0 || year % 400 === 0)) {
      return 29;
    }
  }
  return DAYS_IN_MONTH[month];
}

var module = __WEBPACK_IMPORTED_MODULE_3_angular___default.a.module('datepicker', ['ui.bootstrap']);

var component = {
  template: __WEBPACK_IMPORTED_MODULE_1__datepicker_html___default.a,
  controller: DatePickerController,
  bindings: {
    value: "=?ngModel",
    minView: "@?",
    format: '@?'
  }
};
DatePickerController.$inject = ['$scope', '$document', '$element', '$log'];

function DatePickerController($scope, $document, $element, $log) {
  var $ctrl = this;
  $ctrl.current = __WEBPACK_IMPORTED_MODULE_2_moment___default.a();
  $ctrl.view = 'day';
  $ctrl.years = [];
  $ctrl.months = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11];
  $ctrl.days = [];
  $ctrl.minView = 'day';
  $ctrl.format = 'yyyy-MM-dd';
  $ctrl.value = $ctrl.current.toDate();

  $ctrl.$onChanges = function (obj) {
    if (obj.minView) {
      if (viewAfter($ctrl.view, $ctrl.minView)) {
        $ctrl.view = $ctrl.minView;
      }
    }
  };

  $ctrl.next = function () {
    switch ($ctrl.view) {
      case 'year':
        $ctrl.current.add(12, 'y');
        break;
      case 'month':
        $ctrl.current.add(1, 'y');
        break;
      case 'day':
        $ctrl.current.add(1, 'M');
        break;
    }
    $ctrl.setCurrent();
  };

  $ctrl.prev = function () {
    switch ($ctrl.view) {
      case 'year':
        $ctrl.current.subtract(12, 'y');
        break;
      case 'month':
        $ctrl.current.subtract(1, 'y');
        break;
      case 'day':
        $ctrl.current.subtract(1, 'M');
        break;
    }
    $ctrl.setCurrent();
  };

  $ctrl.setView = function (type) {
    if (viewAfter(type, $ctrl.minView)) {
      $ctrl.value = $ctrl.current.toDate();
      $ctrl.isOpen = false;
    } else {
      $ctrl.view = type;
    }
  };

  $ctrl.isCurrent = function (type, value) {
    switch (type) {
      case "year":
        return $ctrl.value.getFullYear() === value;
        break;
      case "month":
        return $ctrl.value.getMonth() === value;
        break;
      case "day":
        return $ctrl.value.getDay() === value;
        break;
    }
  };

  $ctrl.setCurrent = function (data) {
    if (data) {
      if (data.year) {
        $ctrl.current.year(data.year);
      }
      if (data.month) {
        $ctrl.current.month(data.month);
      }
      if (data.date) {
        $ctrl.current.date(data.date);
      }
    }

    var year = $ctrl.current.year();
    var month = $ctrl.current.month();
    var date = $ctrl.current.date();
    var years = [];
    var days = [];
    for (var i = year - 5; i < year + 7; i++) {
      years.push(i);
    }
    $ctrl.years = years;
    var dayCount = getDays(year, month);
    for (var _i = 0; _i < dayCount; _i++) {
      days.push({ year: year, month: month, date: _i + 1 });
    }

    var first = __WEBPACK_IMPORTED_MODULE_2_moment___default.a(new Date(year, month, days[0].date));
    var last = __WEBPACK_IMPORTED_MODULE_2_moment___default.a(new Date(year, month, dayCount));
    for (var _i2 = first.day(); _i2 > 0; _i2--) {
      first.subtract(1, 'd');
      days.unshift({ year: first.year(), month: first.month(), date: first.date() });
    }
    for (var _i3 = last.day(); _i3 < 6; _i3++) {
      last.add(1, 'd');
      days.push({ year: last.year(), month: last.month(), date: last.date() });
    }

    $ctrl.days = days;
    return true;
  };

  $ctrl.setCurrent();

  $ctrl.getDisabled = function () {
    return $element.attr('disabled') === 'disabled';
  };
}

module.component('datepicker', component);

/* harmony default export */ __webpack_exports__["default"] = ('datepicker');

/***/ }),
/* 1 */
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = "<div class=\"datepicker\" uib-dropdown is-open=\"$ctrl.isOpen\" auto-close=\"outsideClick\">\r\n  <div ng-if=\"$ctrl.getDisabled()\" class=\"form-control\">{{$ctrl.value | date:$ctrl.format}}</div>\r\n  <div ng-if=\"!$ctrl.getDisabled()\" uib-dropdown-toggle class=\"form-control\">{{$ctrl.value | date:$ctrl.format}}</div>\r\n  <div uib-dropdown-menu class=\"picker-wrapper\">\r\n    <div ng-show=\"$ctrl.view==='year'\" class=\"year\">\r\n      <div class=\"header clearfix\">\r\n        <div class=\"prev\"><a ng-click=\"$ctrl.prev()\">‹</a></div>\r\n        <div class=\"current\">{{$ctrl.current.year()-5}}-{{$ctrl.current.year()+6}}</div>\r\n        <div class=\"next\"><a ng-click=\"$ctrl.next()\">›</a></div>\r\n      </div>\r\n      <ul class=\"clearfix\">\r\n        <li ng-repeat=\"y in $ctrl.years\" ng-class=\"{'value':$ctrl.value.getFullYear()===y}\">\r\n          <a ng-click=\"$ctrl.setCurrent({year:y}) && $ctrl.setView('month')\" href=\"javascript:void(0)\">{{y}}</a>\r\n        </li>\r\n      </ul>\r\n    </div>\r\n    <div ng-show=\"$ctrl.view=='month'\" class=\"month\">\r\n      <div class=\"header clearfix\">\r\n        <div class=\"prev\"><a href=\"javascript:void(0)\" ng-click=\"$ctrl.prev()\">‹</a>\r\n        </div>\r\n        <div class=\"current\"><a ng-click=\"$ctrl.setView('year')\" href=\"javascript:void(0)\">{{$ctrl.current.year()}}</a>\r\n        </div>\r\n        <div class=\"next\"><a href=\"javascript:void(0)\" ng-click=\"$ctrl.next()\">›</a>\r\n        </div>\r\n      </div>\r\n      <ul class=\"clearfix\">\r\n        <li ng-repeat=\"m in $ctrl.months\" ng-class=\"{'value':$ctrl.value.getMonth()===m}\">\r\n          <a ng-click=\"$ctrl.setCurrent({month:m}) && $ctrl.setView('day')\" href=\"javascript:void(0)\">{{m+1}}</a></li>\r\n      </ul>\r\n    </div>\r\n    <div ng-show=\"$ctrl.view=='day'\" class=\"day\">\r\n      <div class=\"header clearfix\">\r\n        <div class=\"prev\"><a ng-click=\"$ctrl.prev()\">‹</a></div>\r\n        <div class=\"current\">\r\n          <a ng-click=\"$ctrl.setView('month')\"\r\n             href=\"javascript:void(0)\">{{$ctrl.current.year()}}年{{$ctrl.current.month()+1}}月</a>\r\n        </div>\r\n        <div class=\"next\"><a ng-click=\"$ctrl.next()\">›</a></div>\r\n      </div>\r\n      <ul class=\"clearfix\">\r\n        <li>日</li>\r\n        <li>一</li>\r\n        <li>二</li>\r\n        <li>三</li>\r\n        <li>四</li>\r\n        <li>五</li>\r\n        <li>六</li>\r\n      </ul>\r\n      <ul class=\"clearfix\">\r\n        <li ng-repeat=\"d in $ctrl.days\"\r\n            ng-class=\"{'value':$ctrl.value.getMonth()===d.month && $ctrl.value.getDate()===d.date,'notcurrent':$ctrl.current.month()!==d.month}\">\r\n          <a ng-click=\"$ctrl.setCurrent(d) && $ctrl.setView('hour',d) \" href=\"javascript:void(0)\">{{d.date}}</a>\r\n        </li>\r\n      </ul>\r\n    </div>\r\n    <div ng-show=\"view=='hour'\">小时视图</div>\r\n  </div>\r\n</div>\r\n";

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_3__;

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_4__;

/***/ })
/******/ ]);
});